import mqtt from "mqtt";

/**
 * Mocks getMqtt to connect to the local dummy-broker instead of
 * the one specified in environment
 * @param onConnectCB Callback to run on connect
 * @param onErr Callback to run on error
 */
const getMockMqtt = async (onConnectCB: () => void = () => {}, onErr: (err?: any) => void = err => {}): Promise<mqtt.MqttClient> => {
    const mqttClient = mqtt.connect("", {
        host: "127.0.0.1",
        protocol: "mqtt",
        port: 1883
    })
    return mqttClient
}
export default getMockMqtt