import {Sequelize} from "sequelize";
import {initReading} from "../models/reading";
import {initMetaData} from "../models/metaData";
import {initVariable} from "../models/variable";
import {initVessel} from "../models/vessel";

/**
 * Initializes Sequelize models to the test database
 */
const initModels = async () => {
    const sequelize = new Sequelize('sqlite::memory:', {dialect: "sqlite", protocol: "sqlite"})

    console.log("Initializing models")
    initVariable(sequelize)
    initVessel(sequelize)
    initReading(sequelize)
    initMetaData(sequelize)
    await sequelize.sync({force: true, logging: false})
    return
}

export default initModels