import aedes, {Aedes} from "aedes";
import net, {Server} from "net";

/**
 * The mock broker
 */
let broker: Aedes

/**
 * The server instance used by the mock broker
 */
let server: Server

/**
 * Starts the mock broker
 */
export const startBroker = () => {
    if (broker == null) {
        broker = aedes()
        server = net.createServer(broker.handle)
        const port = 1883
        server.listen(port)
    }
}

/**
 * Stops the mock broker
 */
export const stopBroker = () => {
    broker.close()
    server.close()
}

/**
 * Returns singleton broker
 */
export const getBroker = () => {
    if (broker == null) throw new Error("Mock broker not initialized")
    return broker
}