import {initReading} from "../models/reading";
import {initMetaData} from "../models/metaData";
import {initVessel} from "../models/vessel";
import {initVariable} from "../models/variable";
import {Sequelize} from "sequelize";

/**
 * Sets up a wirelogger_test database on the env specified database
 * This database is only to be used in testing
 */
const setupDB = async () => {
    const sequelize = new Sequelize('sqlite::memory:', {dialect: "sqlite", protocol: "sqlite"})
    console.log("Initializing models")
    initVariable(sequelize)
    initVessel(sequelize)
    initReading(sequelize)
    initMetaData(sequelize)
    await sequelize.sync({force: true, logging: false})
}
export default setupDB