import configEnv from "../configuration/configEnv";
import setupTestDB from "./setupTestDB";
import fs from "fs";
import path from "path";
import Reading from "../models/reading";
import {startBroker} from "./mockBroker";
import {start} from "./mockVesselClient";

/**
 * Sets up all infrastructural test dependencies
 */
const setupDeps = async () => {
    console.log("Setting up test dependencies")
    if (!fs.existsSync(path.resolve(process.cwd(), "./logs"))) {
        fs.mkdirSync(path.resolve(process.cwd(), "./logs"))
    }
    configEnv()

    console.log("Setting up test database")
    await setupTestDB();
    if (Reading.sequelize == null) {
        console.log("Could not connect to database")
        process.exit(1)
    }

    console.log("Starting test broker")
    startBroker()

    console.log("Starting test client")
    await start()

}
export default setupDeps