import { start } from '../.jest/mockVesselClient'
import getMQTTClient from '../services/mqtt/getMQTTClient'
import dotenv from 'dotenv'
import path from 'path'

/**
 * Creates mqtt client mocking a vessel
 */
;(async () => {
  dotenv.config({
    path: path.resolve(process.cwd(), '.env')
  })
  if (!process.env.MQTT_BROKER_ADDRESS) {
    console.log('Missing required "MQTT_BROKER_ADDRESS" parameter')
    process.exit(1)
  }
  const mqtt = await getMQTTClient()
  await start(mqtt)
})()
