import { CreationOptional, HasManyCreateAssociationMixin, HasManyGetAssociationsMixin, InferAttributes, InferCreationAttributes, Model, NonAttribute, Sequelize } from 'sequelize';
import Reading from './reading';
export declare class Vessel extends Model<InferAttributes<Vessel>, InferCreationAttributes<Vessel>> {
    id: CreationOptional<number>;
    name: string;
    addReading: HasManyCreateAssociationMixin<Reading>;
    getReadings: HasManyGetAssociationsMixin<Reading>;
    readings: NonAttribute<Reading>;
}
export declare const initVessel: (sequelize: Sequelize) => typeof Vessel;
export declare const NAMEVALIDATOR: RegExp;
