export declare class EntityData {
    readonly id: number;
    readonly hash: string;
    readonly name: string;
    readonly type: 'vessel' | 'variable';
    uses: number;
    constructor(args: {
        hash: string;
        name: string;
        id: number;
    }, type: 'vessel' | 'variable');
    addUse(): void;
    subUse(): void;
}
export default class EntityDataController {
    private static vesselState;
    private static variableState;
    static remove(node: EntityData): void;
    private static add;
    static vesselById(id: number): EntityData;
    static vesselByName(name: string): Promise<EntityData>;
    static vesselByHash(hash: string): EntityData;
    static variableById(id: number): EntityData;
    static variableByName(name: string): Promise<EntityData>;
    static variableByHash(hash: string): EntityData;
}
