export interface SubFunc {
    (entry: StreamStateEntry): void;
    id: string;
}
export declare class StreamStateEntry {
    vessel: string;
    variable: string;
    from: number;
    to: number;
    private subs;
    status: boolean | string;
    localPath?: string;
    private useCount;
    constructor(vessel: string, variable: string, from: number, to: number);
    setPath(path: string): void;
    subUse(this: StreamStateEntry): void;
    addUse(): void;
    setStatus(status: boolean | string): void;
    sub(func: (a: boolean | string) => void): void;
    equals(this: StreamStateEntry, subject: StreamStateEntry): boolean;
}
export default class StreamStateController {
    private static streamState;
    static getInRange(vessel: string, variable: string, from: number, to: number): StreamStateEntry[];
    static subOnAdd(vessel: string, variable: string, func: Partial<SubFunc>): SubFunc;
    static subOnRemove(vessel: string, variable: string, func: Partial<SubFunc>): SubFunc;
    private static sub;
    static unsubOnAdd(vessel: string, variable: string, func: SubFunc): void;
    static unsubOnRemove(vessel: string, variable: string, func: SubFunc): void;
    private static unsub;
    static getOrCreate(vessel: string, variable: string, from: number, to: number): StreamStateEntry;
    static create(vessel: string, variable: string, from: number, to: number): StreamStateEntry;
    static get(vessel: string, variable: string, from: number, to: number): StreamStateEntry | undefined;
    static remove(entry: StreamStateEntry): void;
}
