import getMQTT from './getMQTTClient'
import { HealthCheck } from '../../proto/wlHealthCheck'

try {
  getMQTT().then(client => {
    const pong = Buffer.from(HealthCheck.encode({ message: 'pong' }).finish())
    setInterval(() => {
      client.publish('wlcache/healthcheck', pong)
    }, 3e3)

    process.on('message', (message: string) => {
      if (message === 'end') {
        client.end(true)
      }
    })
  }).catch(e => process.send!(e.message))
} catch (e: any) {
  process.send!(e.message)
  process.exit()
}
