import discover from '../handlers/data/discover'
import { testVessel } from '../.jest/testConst'
import getMQTT from '../services/mqtt/getMQTTClient'
import byteCounter from '../services/logging/byteCounter'
import getMockMQTT from '../.jest/getMockMQTT'
import MqttPool, { MqttPoolClient } from '../services/mqtt/mqttPool'

jest.setTimeout(1e4) // timeout for discover is 10 seconds

jest.mock('../services/mqtt/getMQTTClient')
const mqttMock = getMQTT as jest.MockedFunction<typeof getMQTT>
mqttMock.mockImplementation(getMockMQTT)

jest.mock('../services/mqtt/mqttPool', () => {
  const actual = jest.requireActual('../services/mqtt/mqttPool')
  actual.default.release = (client: MqttPoolClient) => client.end(true)
  return actual
})

it('Should retrieve all the unique types of data on a vessel', async () => {
  const dataCost = byteCounter()
  const response = await discover(testVessel, dataCost)

  expect(dataCost.get()).not.toBe(0)
  expect(response.length).not.toBe(0)
  Object.keys(response).forEach(key => {

  })
})
