import initModels from '../.jest/initModels'
import EntityDataController from '../services/database/entityDataController'

beforeAll(async () => {
  await initModels()
})

it('Should delete a record once uses reach 0, and not allow further subtractions', async () => {
  const node = await EntityDataController.vesselByName('Name')
  expect(node.uses).toBe(1)
  EntityDataController.vesselById(node.id)
  expect(node.uses).toBe(2)
  EntityDataController.vesselByHash(node.hash)
  expect(node.uses).toBe(3)

  node.subUse()
  expect(node.uses).toBe(2)
  node.subUse()
  node.subUse()

  expect(() => EntityDataController.vesselById(node.id)).toThrowError()
  expect(() => EntityDataController.vesselByHash(node.hash)).toThrowError()
})

it('Should do the same with variable ndoes', async () => {
  const node = await EntityDataController.variableByName('Name')
  expect(node.uses).toBe(1)
  EntityDataController.variableById(node.id)
  expect(node.uses).toBe(2)
  EntityDataController.variableByHash(node.hash)
  expect(node.uses).toBe(3)

  node.subUse()
  expect(node.uses).toBe(2)
  node.subUse()
  node.subUse()

  expect(() => EntityDataController.variableById(node.id)).toThrowError()
  expect(() => EntityDataController.variableByHash(node.hash)).toThrowError()
})
