import fetchLast from '../handlers/data/fetchLast'
import { testVariables, testVessel } from '../.jest/testConst'
import byteCounter from '../services/logging/byteCounter'
import getMQTT from '../services/mqtt/getMQTTClient'
import getMockMQTT from '../.jest/getMockMQTT'
import MqttPool, { MqttPoolClient } from '../services/mqtt/mqttPool'

jest.setTimeout(1e4)

jest.mock('../services/mqtt/getMQTTClient')
const mqttMock = getMQTT as jest.MockedFunction<typeof getMQTT>
mqttMock.mockImplementation(getMockMQTT)

jest.mock('../services/mqtt/mqttPool', () => {
  const actual = jest.requireActual('../services/mqtt/mqttPool')
  actual.default.release = (client: MqttPoolClient) => client.end(true)
  return actual
})

it('Should get the last n of the given data', async () => {
  const dataCost = byteCounter()
  const response = await fetchLast(testVessel, testVariables, 10, dataCost)
  expect(dataCost.get()).not.toBe(0)
  expect(response).toBeDefined()
  response.forEach(signal => {
    expect(testVariables.includes(signal.name)).toBe(true)
    expect(Object.keys(signal.double)).not.toBe(0)
  })
  expect(response.length).toBe(testVariables.length)
})
