# Time-Series Cache Web (Next.js + Chakra UI + Chart.js)

Application in written in [TypeScript](https://www.typescriptlang.org/) with [Next.js](https://nextjs.org/), [Chakra UI](https://chakra-ui.com/) an [Chart.js](https://www.chartjs.org/)
# Contents
 * [Getting started](#getting-started)
 * [Contributing](#contributing)

# Getting started
To run the Time-Series Cache Website, you first need to start up the backend containing the following:
 * [An MQTT broker](https://mosquitto.org/)
 * [A TimescaleDB database](https://www.timescale.com/)
 * [The Time-Series Cache](https://github.com/WireloggerProject/caching_service)
 * [The Time-Series REST service](https://github.com/WireloggerProject/rest_service)
 * One or more vessel serivces, or the [vessel mock](https://hub.docker.com/repository/docker/davidrk/vesselmock)

To avoid having to set up all the dependencies, you can instead run our [docker compose](https://github.com/WireloggerProject/docker)  
This will start up all dependencies including the vessel mock service

## Run Project
To run the project, the first step is to set up the necessary [environment variables](#environment)
### Node
Use [Node.js](https://nodejs.org/en/) to run project in terminal with following commands:

```bash
$ npm install
$ npm run dev
```

### Docker
The frontend is available at the [docker repo](https://hub.docker.com/repository/docker/davidrk/wlfe).  
It can be run with the following command:  
`docker run -d --env-file ./.env davidrk/wlfe`

## Environment
NEXT_PUBLIC_CACHE_URL
 * For deployed API https://wirelogger.com/api/
 * For local API http://localhost:3001/


# Contributing
Please open an issue first to discuss what you would like to change.

Please make sure to update tests as appropriate.

## License
[MIT](https://choosealicense.com/licenses/mit/)