describe("Navigate Website", () => {
  // For desktop view
  describe("When clicking on nav links", () => {
    it("Should visit home page", () => {
      cy.visit("/");
      cy.get("p").contains("Vessels");
      cy.get("p").contains("About");
    });
    it("Bad path", () => {
      cy.visit("/vessel/test_lab", { failOnStatusCode: false });
      cy.get("h2").contains("404");
      cy.get("button").contains("Go Back");
    });
    it("Click Vessels", () => {
      cy.get('*[class^="/vessels"]').click();
    });
    it("Click test_lab", () => {
      cy.get('*[class^="/vessels/test_lab/page/1"]').click();
    });
    it("Search for signal", () => {
      cy.get("input").type("id");
    });
    it("Click Signal", () => {
      cy.get("p").contains("Idawd").click();
    });
    it("Open Modal and browse", () => {
      cy.get("button").get('*[name^="modal-button"]').click();
      cy.get('*[class^="next"]').click();
      cy.get('*[class^="next"]').click();
      cy.get('*[class^="previous"]').click();
      cy.get('*[class^="previous"]').click();
    });
    it("Search and add comparison", () => {
        cy.get("input").get('*[name^="search"]').type("eu");
        cy.get("p").contains("Eutrum").click();
      });
      it("Send request for new signal", () => {
        cy.get("input").get('*[name^="lastn"]').type("30");
        cy.get("button").get('*[name^="send-lastn"]').click();
      });
  });
});
