module.exports = {
  publicRuntimeConfig: {
    // Will be available on both server and client
    cache_url: process.env.NEXT_PUBLIC_CACHE_URL
  },
  /**
   * This function is run at build time to set entry point of website
   * Since we want our application to start at /vessels, we redirect all traffic from / => /vessels
   *
   * @returns {object} redirects
   */
  async redirects () {
    return [
      {
        source: '/',
        destination: '/vessels',
        permanent: true
      }
    ]
  }
}
