import { Box, Flex, Heading, Text } from '@chakra-ui/layout'
import { Button } from '@chakra-ui/react'
import Router from 'next/router'
import { ReactElement } from 'react'
import HeadComponent from '../components/shared/head'

/**
 * Functional Component for rendering 404 Not Found Page
 *
 * @returns {ReactElement} functional component
 */
const NotFound = (): ReactElement => {
  return (
    <Flex my="auto" flex="1">
      <HeadComponent title="Not Found" />
      <Box flex="1" mx="auto" my="auto" textAlign="center" py={10} px={6} fontWeight={500}>
        <Heading display="inline-block" as="h2" size="2xl" bgGradient="linear(to-r, red.400, red.600)" backgroundClip="text">
          404
        </Heading>
        <Text fontSize="18px" mt={3} mb={2}>
          Page Not Found
        </Text>
        <Text color={'gray.500'} mb={6}>
          The page you're looking for does not seem to exist
        </Text>

        <Button onClick={() => Router.back()}>Go Back</Button>
      </Box>
    </Flex>
  )
}

export default NotFound
