import { Box, Flex, Heading, Text } from '@chakra-ui/layout'
import { Button } from '@chakra-ui/react'
import Router from 'next/router'
import { ReactElement } from 'react'
import HeadComponent from '../components/shared/head'

/**
 * Functional Component for rendering Service Unavailable Page
 *
 * @returns {ReactElement} functional component
 */
const ServiceUnavailable = (): ReactElement => {
  return (
    <Flex my="auto" mx="auto">
      <HeadComponent title="503 Unavailable" />
      <Box mx="auto" my="auto" textAlign="center" py={10} px={6} fontWeight={500}>
        <Heading display="inline-block" as="h2" size="2xl" bgGradient="linear(to-r, red.400, red.600)" backgroundClip="text">
          503
        </Heading>
        <Text fontSize="18px" mt={3} mb={2}>
          Service Unavailable
        </Text>
        <Text color={'gray.500'} mb={6}>
          The service you're trying to reach is temporary unavailable
        </Text>
        <Button onClick={() => Router.back()}>Try again</Button>
      </Box>
    </Flex>
  )
}

export default ServiceUnavailable
