import { NetworkResponse, RangePayload } from '../globals'
import { _post } from './methods'

/**
 * Method for calling raw wipe call
 *
 * @param {RangePayload} args Wipe payload
 * @returns {Promise<NetworkResponse | string>} response
 */
export const wipe = ({ vesselid, signals, from, to }: Partial<RangePayload>): Promise<NetworkResponse | string> => {
  return _post('command/wipe', {
    vessel: vesselid,
    data: signals,
    ranges: {
      from,
      to
    }
  })
}
