import { NetworkResponse, RangePayload } from '../globals'
import { _get } from './methods'

/**
 * Method for calling raw metadata call
 *
 * @param {Partial<RangePayload>} args Metadata arguments
 * @returns {Promise<NetworkResponse | string>} response
 */
export const getMetadata = ({ vesselid, signals, from, to }: Partial<RangePayload>): Promise<NetworkResponse | string> => _get(`${vesselid}/metadata/${signals.toString()}?from=${from}&to=${to}`)
