import { mode } from '@chakra-ui/theme-tools'

export const container = {
  baseStyle: {
    bg: 'red.200'
  },
  sizes: {},
  variants: {
    /**
     * Primary Theme Callback
     *
     * @param {any} props container props
     * @returns {any} container theme
     */
    primary: (props: any) => ({
      color: mode('gray.800', 'whiteAlpha.900')(props),
      bgColor: mode('gray.300', 'gray.700')(props)
    }),
    /**
     * Base Theme Callback
     *
     * @param {any} props container props
     * @returns {any} container theme
     */
    base: (props: any) => ({
      color: mode('gray.800', 'whiteAlpha.900')(props),
      bg: 'transparent'
    })
  },
  defaultProps: {
    variant: 'primary'
  }
}
