import { extendTheme } from '@chakra-ui/react'
import { button as Button } from './components/button'
import { container as Container } from './components/container'
import { input as Input } from './components/input'
import { link as Link } from './components/link'
import { styles } from './styles'

const shadows = {
  outline: '0 0 0 3px var(--chakra-colors-gray-500)'
}

const config = {
  initialColorMode: 'dark',
  useSystemColorMode: false
}

const theme = extendTheme({
  config,
  colors: {
    primary: 'blue.500'
  },
  styles,
  components: {
    NumberInput: Input,
    Button,
    Container,
    Input,
    Link
  },
  shadows
})

export default theme
