import dotenv from 'dotenv'
import * as path from 'path'

/**
 *  Asynchronously loads environment variables
 *
 *  If required variables are not set, it will be logged to the console and the service will exit
 */
const configEnv = async () => {
  await dotenv.config({
    path: path.resolve(process.cwd(), '.env')
  })
  let misConfigured = false
  if (!process.env.MQTT_BROKER_ADDRESS) {
    misConfigured = true
    console.log('Missing required "MQTT_BROKER_ADDRESS" parameter')
  }
  if (misConfigured) process.exit(1)
}

export default configEnv
