import _m0 from "protobufjs/minimal";
export declare const protobufPackage = "com.seaonics.seabrief.protocol";
export interface Config {
    log: Config_Log[];
}
export declare enum Config_type {
    BASIC = 0,
    COMPACT_DATASTORE_V1 = 1,
    COMPACT_DATASTORE_V2 = 2,
    EVENTS = 3,
    WIRELOG = 4,
    UNRECOGNIZED = -1
}
export declare function config_typeFromJSON(object: any): Config_type;
export declare function config_typeToJSON(object: Config_type): string;
export interface Config_Log {
    type: Config_type;
    path: string;
    name: string;
}
export interface Signal {
    name: string;
    double: {
        [key: string]: number;
    };
}
export interface Signal_DoubleEntry {
    key: string;
    value: number;
}
export interface Error {
    code: number;
    message: string;
}
export interface Changes {
    fromTo: Changes_FromTo | undefined;
    lastN: Changes_LastN | undefined;
    signal: Signal[];
    error?: Error | undefined;
    bytecost?: number | undefined;
}
export interface Changes_FromTo {
    fromTime: string;
    toTime: string;
}
export interface Changes_LastN {
    nChanges: string;
}
export interface KeyFrame {
    atTime: string;
    result: KeyFrame_Result | undefined;
}
export interface KeyFrame_Result {
    valueMap: {
        [key: string]: number;
    };
    timeStamp: string;
}
export interface KeyFrame_Result_ValueMapEntry {
    key: string;
    value: number;
}
export declare const Config: {
    encode(message: Config, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): Config;
    fromJSON(object: any): Config;
    toJSON(message: Config): unknown;
    fromPartial<I extends {
        log?: {
            type?: Config_type | undefined;
            path?: string | undefined;
            name?: string | undefined;
        }[] | undefined;
    } & {
        log?: ({
            type?: Config_type | undefined;
            path?: string | undefined;
            name?: string | undefined;
        }[] & ({
            type?: Config_type | undefined;
            path?: string | undefined;
            name?: string | undefined;
        } & {
            type?: Config_type | undefined;
            path?: string | undefined;
            name?: string | undefined;
        } & Record<Exclude<keyof I["log"][number], keyof Config_Log>, never>)[] & Record<Exclude<keyof I["log"], keyof {
            type?: Config_type | undefined;
            path?: string | undefined;
            name?: string | undefined;
        }[]>, never>) | undefined;
    } & Record<Exclude<keyof I, "log">, never>>(object: I): Config;
};
export declare const Config_Log: {
    encode(message: Config_Log, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): Config_Log;
    fromJSON(object: any): Config_Log;
    toJSON(message: Config_Log): unknown;
    fromPartial<I extends {
        type?: Config_type | undefined;
        path?: string | undefined;
        name?: string | undefined;
    } & {
        type?: Config_type | undefined;
        path?: string | undefined;
        name?: string | undefined;
    } & Record<Exclude<keyof I, keyof Config_Log>, never>>(object: I): Config_Log;
};
export declare const Signal: {
    encode(message: Signal, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): Signal;
    fromJSON(object: any): Signal;
    toJSON(message: Signal): unknown;
    fromPartial<I extends {
        name?: string | undefined;
        double?: {
            [x: string]: number | undefined;
        } | undefined;
    } & {
        name?: string | undefined;
        double?: ({
            [x: string]: number | undefined;
        } & {
            [x: string]: number | undefined;
        } & Record<Exclude<keyof I["double"], string | number>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof Signal>, never>>(object: I): Signal;
};
export declare const Signal_DoubleEntry: {
    encode(message: Signal_DoubleEntry, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): Signal_DoubleEntry;
    fromJSON(object: any): Signal_DoubleEntry;
    toJSON(message: Signal_DoubleEntry): unknown;
    fromPartial<I extends {
        key?: string | undefined;
        value?: number | undefined;
    } & {
        key?: string | undefined;
        value?: number | undefined;
    } & Record<Exclude<keyof I, keyof Signal_DoubleEntry>, never>>(object: I): Signal_DoubleEntry;
};
export declare const Error: {
    encode(message: Error, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): Error;
    fromJSON(object: any): Error;
    toJSON(message: Error): unknown;
    fromPartial<I extends {
        code?: number | undefined;
        message?: string | undefined;
    } & {
        code?: number | undefined;
        message?: string | undefined;
    } & Record<Exclude<keyof I, keyof Error>, never>>(object: I): Error;
};
export declare const Changes: {
    encode(message: Changes, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): Changes;
    fromJSON(object: any): Changes;
    toJSON(message: Changes): unknown;
    fromPartial<I extends {
        fromTo?: {
            fromTime?: string | undefined;
            toTime?: string | undefined;
        } | undefined;
        lastN?: {
            nChanges?: string | undefined;
        } | undefined;
        signal?: {
            name?: string | undefined;
            double?: {
                [x: string]: number | undefined;
            } | undefined;
        }[] | undefined;
        error?: {
            code?: number | undefined;
            message?: string | undefined;
        } | undefined;
        bytecost?: number | undefined;
    } & {
        fromTo?: ({
            fromTime?: string | undefined;
            toTime?: string | undefined;
        } & {
            fromTime?: string | undefined;
            toTime?: string | undefined;
        } & Record<Exclude<keyof I["fromTo"], keyof Changes_FromTo>, never>) | undefined;
        lastN?: ({
            nChanges?: string | undefined;
        } & {
            nChanges?: string | undefined;
        } & Record<Exclude<keyof I["lastN"], "nChanges">, never>) | undefined;
        signal?: ({
            name?: string | undefined;
            double?: {
                [x: string]: number | undefined;
            } | undefined;
        }[] & ({
            name?: string | undefined;
            double?: {
                [x: string]: number | undefined;
            } | undefined;
        } & {
            name?: string | undefined;
            double?: ({
                [x: string]: number | undefined;
            } & {
                [x: string]: number | undefined;
            } & Record<Exclude<keyof I["signal"][number]["double"], string | number>, never>) | undefined;
        } & Record<Exclude<keyof I["signal"][number], keyof Signal>, never>)[] & Record<Exclude<keyof I["signal"], keyof {
            name?: string | undefined;
            double?: {
                [x: string]: number | undefined;
            } | undefined;
        }[]>, never>) | undefined;
        error?: ({
            code?: number | undefined;
            message?: string | undefined;
        } & {
            code?: number | undefined;
            message?: string | undefined;
        } & Record<Exclude<keyof I["error"], keyof Error>, never>) | undefined;
        bytecost?: number | undefined;
    } & Record<Exclude<keyof I, keyof Changes>, never>>(object: I): Changes;
};
export declare const Changes_FromTo: {
    encode(message: Changes_FromTo, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): Changes_FromTo;
    fromJSON(object: any): Changes_FromTo;
    toJSON(message: Changes_FromTo): unknown;
    fromPartial<I extends {
        fromTime?: string | undefined;
        toTime?: string | undefined;
    } & {
        fromTime?: string | undefined;
        toTime?: string | undefined;
    } & Record<Exclude<keyof I, keyof Changes_FromTo>, never>>(object: I): Changes_FromTo;
};
export declare const Changes_LastN: {
    encode(message: Changes_LastN, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): Changes_LastN;
    fromJSON(object: any): Changes_LastN;
    toJSON(message: Changes_LastN): unknown;
    fromPartial<I extends {
        nChanges?: string | undefined;
    } & {
        nChanges?: string | undefined;
    } & Record<Exclude<keyof I, "nChanges">, never>>(object: I): Changes_LastN;
};
export declare const KeyFrame: {
    encode(message: KeyFrame, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): KeyFrame;
    fromJSON(object: any): KeyFrame;
    toJSON(message: KeyFrame): unknown;
    fromPartial<I extends {
        atTime?: string | undefined;
        result?: {
            valueMap?: {
                [x: string]: number | undefined;
            } | undefined;
            timeStamp?: string | undefined;
        } | undefined;
    } & {
        atTime?: string | undefined;
        result?: ({
            valueMap?: {
                [x: string]: number | undefined;
            } | undefined;
            timeStamp?: string | undefined;
        } & {
            valueMap?: ({
                [x: string]: number | undefined;
            } & {
                [x: string]: number | undefined;
            } & Record<Exclude<keyof I["result"]["valueMap"], string | number>, never>) | undefined;
            timeStamp?: string | undefined;
        } & Record<Exclude<keyof I["result"], keyof KeyFrame_Result>, never>) | undefined;
    } & Record<Exclude<keyof I, keyof KeyFrame>, never>>(object: I): KeyFrame;
};
export declare const KeyFrame_Result: {
    encode(message: KeyFrame_Result, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): KeyFrame_Result;
    fromJSON(object: any): KeyFrame_Result;
    toJSON(message: KeyFrame_Result): unknown;
    fromPartial<I extends {
        valueMap?: {
            [x: string]: number | undefined;
        } | undefined;
        timeStamp?: string | undefined;
    } & {
        valueMap?: ({
            [x: string]: number | undefined;
        } & {
            [x: string]: number | undefined;
        } & Record<Exclude<keyof I["valueMap"], string | number>, never>) | undefined;
        timeStamp?: string | undefined;
    } & Record<Exclude<keyof I, keyof KeyFrame_Result>, never>>(object: I): KeyFrame_Result;
};
export declare const KeyFrame_Result_ValueMapEntry: {
    encode(message: KeyFrame_Result_ValueMapEntry, writer?: _m0.Writer): _m0.Writer;
    decode(input: _m0.Reader | Uint8Array, length?: number | undefined): KeyFrame_Result_ValueMapEntry;
    fromJSON(object: any): KeyFrame_Result_ValueMapEntry;
    toJSON(message: KeyFrame_Result_ValueMapEntry): unknown;
    fromPartial<I extends {
        key?: string | undefined;
        value?: number | undefined;
    } & {
        key?: string | undefined;
        value?: number | undefined;
    } & Record<Exclude<keyof I, keyof KeyFrame_Result_ValueMapEntry>, never>>(object: I): KeyFrame_Result_ValueMapEntry;
};
declare type Builtin = Date | Function | Uint8Array | string | number | boolean | undefined;
export declare type DeepPartial<T> = T extends Builtin ? T : T extends Array<infer U> ? Array<DeepPartial<U>> : T extends ReadonlyArray<infer U> ? ReadonlyArray<DeepPartial<U>> : T extends {} ? {
    [K in keyof T]?: DeepPartial<T[K]>;
} : Partial<T>;
declare type KeysOfUnion<T> = T extends T ? keyof T : never;
export declare type Exact<P, I extends P> = P extends Builtin ? P : P & {
    [K in keyof P]: Exact<P[K], I[K]>;
} & Record<Exclude<keyof I, KeysOfUnion<P>>, never>;
export {};
