/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";

export const protobufPackage = "com.seaonics.seabrief.protocol";

export interface Config {
  log: Config_Log[];
}

export enum Config_type {
  BASIC = 0,
  COMPACT_DATASTORE_V1 = 1,
  COMPACT_DATASTORE_V2 = 2,
  EVENTS = 3,
  WIRELOG = 4,
  UNRECOGNIZED = -1,
}

export function config_typeFromJSON(object: any): Config_type {
  switch (object) {
    case 0:
    case "BASIC":
      return Config_type.BASIC;
    case 1:
    case "COMPACT_DATASTORE_V1":
      return Config_type.COMPACT_DATASTORE_V1;
    case 2:
    case "COMPACT_DATASTORE_V2":
      return Config_type.COMPACT_DATASTORE_V2;
    case 3:
    case "EVENTS":
      return Config_type.EVENTS;
    case 4:
    case "WIRELOG":
      return Config_type.WIRELOG;
    case -1:
    case "UNRECOGNIZED":
    default:
      return Config_type.UNRECOGNIZED;
  }
}

export function config_typeToJSON(object: Config_type): string {
  switch (object) {
    case Config_type.BASIC:
      return "BASIC";
    case Config_type.COMPACT_DATASTORE_V1:
      return "COMPACT_DATASTORE_V1";
    case Config_type.COMPACT_DATASTORE_V2:
      return "COMPACT_DATASTORE_V2";
    case Config_type.EVENTS:
      return "EVENTS";
    case Config_type.WIRELOG:
      return "WIRELOG";
    default:
      return "UNKNOWN";
  }
}

export interface Config_Log {
  type: Config_type;
  path: string;
  name: string;
}

export interface Signal {
  name: string;
  double: { [key: string]: number };
}

export interface Signal_DoubleEntry {
  key: string;
  value: number;
}

export interface Error {
  code: number;
  message: string;
}

export interface Changes {
  fromTo: Changes_FromTo | undefined;
  lastN: Changes_LastN | undefined;
  signal: Signal[];
  error?: Error | undefined;
  bytecost?: number | undefined;
}

export interface Changes_FromTo {
  fromTime: string;
  toTime: string;
}

export interface Changes_LastN {
  nChanges: string;
}

export interface KeyFrame {
  atTime: string;
  result: KeyFrame_Result | undefined;
}

export interface KeyFrame_Result {
  valueMap: { [key: string]: number };
  timeStamp: string;
}

export interface KeyFrame_Result_ValueMapEntry {
  key: string;
  value: number;
}

function createBaseConfig(): Config {
  return { log: [] };
}

export const Config = {
  encode(
    message: Config,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    for (const v of message.log) {
      Config_Log.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Config {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseConfig();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.log.push(Config_Log.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): Config {
    return {
      log: Array.isArray(object?.log)
        ? object.log.map((e: any) => Config_Log.fromJSON(e))
        : [],
    };
  },

  toJSON(message: Config): unknown {
    const obj: any = {};
    if (message.log) {
      obj.log = message.log.map((e) => (e ? Config_Log.toJSON(e) : undefined));
    } else {
      obj.log = [];
    }
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<Config>, I>>(object: I): Config {
    const message = createBaseConfig();
    message.log = object.log?.map((e) => Config_Log.fromPartial(e)) || [];
    return message;
  },
};

function createBaseConfig_Log(): Config_Log {
  return { type: 0, path: "", name: "" };
}

export const Config_Log = {
  encode(
    message: Config_Log,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.type !== 0) {
      writer.uint32(8).int32(message.type);
    }
    if (message.path !== "") {
      writer.uint32(18).string(message.path);
    }
    if (message.name !== "") {
      writer.uint32(26).string(message.name);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Config_Log {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseConfig_Log();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.type = reader.int32() as any;
          break;
        case 2:
          message.path = reader.string();
          break;
        case 3:
          message.name = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): Config_Log {
    return {
      type: isSet(object.type) ? config_typeFromJSON(object.type) : 0,
      path: isSet(object.path) ? String(object.path) : "",
      name: isSet(object.name) ? String(object.name) : "",
    };
  },

  toJSON(message: Config_Log): unknown {
    const obj: any = {};
    message.type !== undefined && (obj.type = config_typeToJSON(message.type));
    message.path !== undefined && (obj.path = message.path);
    message.name !== undefined && (obj.name = message.name);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<Config_Log>, I>>(
    object: I
  ): Config_Log {
    const message = createBaseConfig_Log();
    message.type = object.type ?? 0;
    message.path = object.path ?? "";
    message.name = object.name ?? "";
    return message;
  },
};

function createBaseSignal(): Signal {
  return { name: "", double: {} };
}

export const Signal = {
  encode(
    message: Signal,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.name !== "") {
      writer.uint32(10).string(message.name);
    }
    Object.entries(message.double).forEach(([key, value]) => {
      Signal_DoubleEntry.encode(
        { key: key as any, value },
        writer.uint32(18).fork()
      ).ldelim();
    });
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Signal {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSignal();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.name = reader.string();
          break;
        case 2:
          const entry2 = Signal_DoubleEntry.decode(reader, reader.uint32());
          if (entry2.value !== undefined) {
            message.double[entry2.key] = entry2.value;
          }
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): Signal {
    return {
      name: isSet(object.name) ? String(object.name) : "",
      double: isObject(object.double)
        ? Object.entries(object.double).reduce<{ [key: string]: number }>(
            (acc, [key, value]) => {
              acc[key] = Number(value);
              return acc;
            },
            {}
          )
        : {},
    };
  },

  toJSON(message: Signal): unknown {
    const obj: any = {};
    message.name !== undefined && (obj.name = message.name);
    obj.double = {};
    if (message.double) {
      Object.entries(message.double).forEach(([k, v]) => {
        obj.double[k] = v;
      });
    }
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<Signal>, I>>(object: I): Signal {
    const message = createBaseSignal();
    message.name = object.name ?? "";
    message.double = Object.entries(object.double ?? {}).reduce<{
      [key: string]: number;
    }>((acc, [key, value]) => {
      if (value !== undefined) {
        acc[key] = Number(value);
      }
      return acc;
    }, {});
    return message;
  },
};

function createBaseSignal_DoubleEntry(): Signal_DoubleEntry {
  return { key: "0", value: 0 };
}

export const Signal_DoubleEntry = {
  encode(
    message: Signal_DoubleEntry,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.key !== "0") {
      writer.uint32(8).int64(message.key);
    }
    if (message.value !== 0) {
      writer.uint32(17).double(message.value);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Signal_DoubleEntry {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseSignal_DoubleEntry();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.key = longToString(reader.int64() as Long);
          break;
        case 2:
          message.value = reader.double();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): Signal_DoubleEntry {
    return {
      key: isSet(object.key) ? String(object.key) : "0",
      value: isSet(object.value) ? Number(object.value) : 0,
    };
  },

  toJSON(message: Signal_DoubleEntry): unknown {
    const obj: any = {};
    message.key !== undefined && (obj.key = message.key);
    message.value !== undefined && (obj.value = message.value);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<Signal_DoubleEntry>, I>>(
    object: I
  ): Signal_DoubleEntry {
    const message = createBaseSignal_DoubleEntry();
    message.key = object.key ?? "0";
    message.value = object.value ?? 0;
    return message;
  },
};

function createBaseError(): Error {
  return { code: 0, message: "" };
}

export const Error = {
  encode(message: Error, writer: _m0.Writer = _m0.Writer.create()): _m0.Writer {
    if (message.code !== 0) {
      writer.uint32(8).int32(message.code);
    }
    if (message.message !== "") {
      writer.uint32(18).string(message.message);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Error {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseError();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.code = reader.int32();
          break;
        case 2:
          message.message = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): Error {
    return {
      code: isSet(object.code) ? Number(object.code) : 0,
      message: isSet(object.message) ? String(object.message) : "",
    };
  },

  toJSON(message: Error): unknown {
    const obj: any = {};
    message.code !== undefined && (obj.code = Math.round(message.code));
    message.message !== undefined && (obj.message = message.message);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<Error>, I>>(object: I): Error {
    const message = createBaseError();
    message.code = object.code ?? 0;
    message.message = object.message ?? "";
    return message;
  },
};

function createBaseChanges(): Changes {
  return {
    fromTo: undefined,
    lastN: undefined,
    signal: [],
    error: undefined,
    bytecost: undefined,
  };
}

export const Changes = {
  encode(
    message: Changes,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.fromTo !== undefined) {
      Changes_FromTo.encode(message.fromTo, writer.uint32(10).fork()).ldelim();
    }
    if (message.lastN !== undefined) {
      Changes_LastN.encode(message.lastN, writer.uint32(18).fork()).ldelim();
    }
    for (const v of message.signal) {
      Signal.encode(v!, writer.uint32(26).fork()).ldelim();
    }
    if (message.error !== undefined) {
      Error.encode(message.error, writer.uint32(34).fork()).ldelim();
    }
    if (message.bytecost !== undefined) {
      writer.uint32(40).int32(message.bytecost);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Changes {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseChanges();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.fromTo = Changes_FromTo.decode(reader, reader.uint32());
          break;
        case 2:
          message.lastN = Changes_LastN.decode(reader, reader.uint32());
          break;
        case 3:
          message.signal.push(Signal.decode(reader, reader.uint32()));
          break;
        case 4:
          message.error = Error.decode(reader, reader.uint32());
          break;
        case 5:
          message.bytecost = reader.int32();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): Changes {
    return {
      fromTo: isSet(object.fromTo)
        ? Changes_FromTo.fromJSON(object.fromTo)
        : undefined,
      lastN: isSet(object.lastN)
        ? Changes_LastN.fromJSON(object.lastN)
        : undefined,
      signal: Array.isArray(object?.signal)
        ? object.signal.map((e: any) => Signal.fromJSON(e))
        : [],
      error: isSet(object.error) ? Error.fromJSON(object.error) : undefined,
      bytecost: isSet(object.bytecost) ? Number(object.bytecost) : undefined,
    };
  },

  toJSON(message: Changes): unknown {
    const obj: any = {};
    message.fromTo !== undefined &&
      (obj.fromTo = message.fromTo
        ? Changes_FromTo.toJSON(message.fromTo)
        : undefined);
    message.lastN !== undefined &&
      (obj.lastN = message.lastN
        ? Changes_LastN.toJSON(message.lastN)
        : undefined);
    if (message.signal) {
      obj.signal = message.signal.map((e) =>
        e ? Signal.toJSON(e) : undefined
      );
    } else {
      obj.signal = [];
    }
    message.error !== undefined &&
      (obj.error = message.error ? Error.toJSON(message.error) : undefined);
    message.bytecost !== undefined &&
      (obj.bytecost = Math.round(message.bytecost));
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<Changes>, I>>(object: I): Changes {
    const message = createBaseChanges();
    message.fromTo =
      object.fromTo !== undefined && object.fromTo !== null
        ? Changes_FromTo.fromPartial(object.fromTo)
        : undefined;
    message.lastN =
      object.lastN !== undefined && object.lastN !== null
        ? Changes_LastN.fromPartial(object.lastN)
        : undefined;
    message.signal = object.signal?.map((e) => Signal.fromPartial(e)) || [];
    message.error =
      object.error !== undefined && object.error !== null
        ? Error.fromPartial(object.error)
        : undefined;
    message.bytecost = object.bytecost ?? undefined;
    return message;
  },
};

function createBaseChanges_FromTo(): Changes_FromTo {
  return { fromTime: "0", toTime: "0" };
}

export const Changes_FromTo = {
  encode(
    message: Changes_FromTo,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.fromTime !== "0") {
      writer.uint32(8).int64(message.fromTime);
    }
    if (message.toTime !== "0") {
      writer.uint32(16).int64(message.toTime);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Changes_FromTo {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseChanges_FromTo();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.fromTime = longToString(reader.int64() as Long);
          break;
        case 2:
          message.toTime = longToString(reader.int64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): Changes_FromTo {
    return {
      fromTime: isSet(object.fromTime) ? String(object.fromTime) : "0",
      toTime: isSet(object.toTime) ? String(object.toTime) : "0",
    };
  },

  toJSON(message: Changes_FromTo): unknown {
    const obj: any = {};
    message.fromTime !== undefined && (obj.fromTime = message.fromTime);
    message.toTime !== undefined && (obj.toTime = message.toTime);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<Changes_FromTo>, I>>(
    object: I
  ): Changes_FromTo {
    const message = createBaseChanges_FromTo();
    message.fromTime = object.fromTime ?? "0";
    message.toTime = object.toTime ?? "0";
    return message;
  },
};

function createBaseChanges_LastN(): Changes_LastN {
  return { nChanges: "0" };
}

export const Changes_LastN = {
  encode(
    message: Changes_LastN,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.nChanges !== "0") {
      writer.uint32(8).int64(message.nChanges);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Changes_LastN {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseChanges_LastN();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.nChanges = longToString(reader.int64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): Changes_LastN {
    return {
      nChanges: isSet(object.nChanges) ? String(object.nChanges) : "0",
    };
  },

  toJSON(message: Changes_LastN): unknown {
    const obj: any = {};
    message.nChanges !== undefined && (obj.nChanges = message.nChanges);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<Changes_LastN>, I>>(
    object: I
  ): Changes_LastN {
    const message = createBaseChanges_LastN();
    message.nChanges = object.nChanges ?? "0";
    return message;
  },
};

function createBaseKeyFrame(): KeyFrame {
  return { atTime: "0", result: undefined };
}

export const KeyFrame = {
  encode(
    message: KeyFrame,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.atTime !== "0") {
      writer.uint32(8).int64(message.atTime);
    }
    if (message.result !== undefined) {
      KeyFrame_Result.encode(message.result, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): KeyFrame {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseKeyFrame();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.atTime = longToString(reader.int64() as Long);
          break;
        case 2:
          message.result = KeyFrame_Result.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): KeyFrame {
    return {
      atTime: isSet(object.atTime) ? String(object.atTime) : "0",
      result: isSet(object.result)
        ? KeyFrame_Result.fromJSON(object.result)
        : undefined,
    };
  },

  toJSON(message: KeyFrame): unknown {
    const obj: any = {};
    message.atTime !== undefined && (obj.atTime = message.atTime);
    message.result !== undefined &&
      (obj.result = message.result
        ? KeyFrame_Result.toJSON(message.result)
        : undefined);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<KeyFrame>, I>>(object: I): KeyFrame {
    const message = createBaseKeyFrame();
    message.atTime = object.atTime ?? "0";
    message.result =
      object.result !== undefined && object.result !== null
        ? KeyFrame_Result.fromPartial(object.result)
        : undefined;
    return message;
  },
};

function createBaseKeyFrame_Result(): KeyFrame_Result {
  return { valueMap: {}, timeStamp: "0" };
}

export const KeyFrame_Result = {
  encode(
    message: KeyFrame_Result,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    Object.entries(message.valueMap).forEach(([key, value]) => {
      KeyFrame_Result_ValueMapEntry.encode(
        { key: key as any, value },
        writer.uint32(10).fork()
      ).ldelim();
    });
    if (message.timeStamp !== "0") {
      writer.uint32(16).int64(message.timeStamp);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): KeyFrame_Result {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseKeyFrame_Result();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          const entry1 = KeyFrame_Result_ValueMapEntry.decode(
            reader,
            reader.uint32()
          );
          if (entry1.value !== undefined) {
            message.valueMap[entry1.key] = entry1.value;
          }
          break;
        case 2:
          message.timeStamp = longToString(reader.int64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): KeyFrame_Result {
    return {
      valueMap: isObject(object.valueMap)
        ? Object.entries(object.valueMap).reduce<{ [key: string]: number }>(
            (acc, [key, value]) => {
              acc[key] = Number(value);
              return acc;
            },
            {}
          )
        : {},
      timeStamp: isSet(object.timeStamp) ? String(object.timeStamp) : "0",
    };
  },

  toJSON(message: KeyFrame_Result): unknown {
    const obj: any = {};
    obj.valueMap = {};
    if (message.valueMap) {
      Object.entries(message.valueMap).forEach(([k, v]) => {
        obj.valueMap[k] = v;
      });
    }
    message.timeStamp !== undefined && (obj.timeStamp = message.timeStamp);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<KeyFrame_Result>, I>>(
    object: I
  ): KeyFrame_Result {
    const message = createBaseKeyFrame_Result();
    message.valueMap = Object.entries(object.valueMap ?? {}).reduce<{
      [key: string]: number;
    }>((acc, [key, value]) => {
      if (value !== undefined) {
        acc[key] = Number(value);
      }
      return acc;
    }, {});
    message.timeStamp = object.timeStamp ?? "0";
    return message;
  },
};

function createBaseKeyFrame_Result_ValueMapEntry(): KeyFrame_Result_ValueMapEntry {
  return { key: "", value: 0 };
}

export const KeyFrame_Result_ValueMapEntry = {
  encode(
    message: KeyFrame_Result_ValueMapEntry,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.key !== "") {
      writer.uint32(10).string(message.key);
    }
    if (message.value !== 0) {
      writer.uint32(17).double(message.value);
    }
    return writer;
  },

  decode(
    input: _m0.Reader | Uint8Array,
    length?: number
  ): KeyFrame_Result_ValueMapEntry {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseKeyFrame_Result_ValueMapEntry();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.key = reader.string();
          break;
        case 2:
          message.value = reader.double();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): KeyFrame_Result_ValueMapEntry {
    return {
      key: isSet(object.key) ? String(object.key) : "",
      value: isSet(object.value) ? Number(object.value) : 0,
    };
  },

  toJSON(message: KeyFrame_Result_ValueMapEntry): unknown {
    const obj: any = {};
    message.key !== undefined && (obj.key = message.key);
    message.value !== undefined && (obj.value = message.value);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<KeyFrame_Result_ValueMapEntry>, I>>(
    object: I
  ): KeyFrame_Result_ValueMapEntry {
    const message = createBaseKeyFrame_Result_ValueMapEntry();
    message.key = object.key ?? "";
    message.value = object.value ?? 0;
    return message;
  },
};

type Builtin =
  | Date
  | Function
  | Uint8Array
  | string
  | number
  | boolean
  | undefined;

export type DeepPartial<T> = T extends Builtin
  ? T
  : T extends Array<infer U>
  ? Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U>
  ? ReadonlyArray<DeepPartial<U>>
  : T extends {}
  ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin
  ? P
  : P & { [K in keyof P]: Exact<P[K], I[K]> } & Record<
        Exclude<keyof I, KeysOfUnion<P>>,
        never
      >;

function longToString(long: Long) {
  return long.toString();
}

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isObject(value: any): boolean {
  return typeof value === "object" && value !== null;
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
