/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";

export const protobufPackage = "";

export interface Ranges {
  from: string;
  to: string;
}

export interface Command {
  action: string;
  vessel?: string | undefined;
  data: string[];
  ranges?: Ranges | undefined;
}

export interface CommandResponse {
  success: boolean;
  error?: string | undefined;
}

function createBaseRanges(): Ranges {
  return { from: "0", to: "0" };
}

export const Ranges = {
  encode(
    message: Ranges,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.from !== "0") {
      writer.uint32(8).int64(message.from);
    }
    if (message.to !== "0") {
      writer.uint32(16).int64(message.to);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Ranges {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseRanges();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.from = longToString(reader.int64() as Long);
          break;
        case 2:
          message.to = longToString(reader.int64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): Ranges {
    return {
      from: isSet(object.from) ? String(object.from) : "0",
      to: isSet(object.to) ? String(object.to) : "0",
    };
  },

  toJSON(message: Ranges): unknown {
    const obj: any = {};
    message.from !== undefined && (obj.from = message.from);
    message.to !== undefined && (obj.to = message.to);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<Ranges>, I>>(object: I): Ranges {
    const message = createBaseRanges();
    message.from = object.from ?? "0";
    message.to = object.to ?? "0";
    return message;
  },
};

function createBaseCommand(): Command {
  return { action: "", vessel: undefined, data: [], ranges: undefined };
}

export const Command = {
  encode(
    message: Command,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.action !== "") {
      writer.uint32(10).string(message.action);
    }
    if (message.vessel !== undefined) {
      writer.uint32(18).string(message.vessel);
    }
    for (const v of message.data) {
      writer.uint32(26).string(v!);
    }
    if (message.ranges !== undefined) {
      Ranges.encode(message.ranges, writer.uint32(34).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): Command {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCommand();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.action = reader.string();
          break;
        case 2:
          message.vessel = reader.string();
          break;
        case 3:
          message.data.push(reader.string());
          break;
        case 4:
          message.ranges = Ranges.decode(reader, reader.uint32());
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): Command {
    return {
      action: isSet(object.action) ? String(object.action) : "",
      vessel: isSet(object.vessel) ? String(object.vessel) : undefined,
      data: Array.isArray(object?.data)
        ? object.data.map((e: any) => String(e))
        : [],
      ranges: isSet(object.ranges) ? Ranges.fromJSON(object.ranges) : undefined,
    };
  },

  toJSON(message: Command): unknown {
    const obj: any = {};
    message.action !== undefined && (obj.action = message.action);
    message.vessel !== undefined && (obj.vessel = message.vessel);
    if (message.data) {
      obj.data = message.data.map((e) => e);
    } else {
      obj.data = [];
    }
    message.ranges !== undefined &&
      (obj.ranges = message.ranges ? Ranges.toJSON(message.ranges) : undefined);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<Command>, I>>(object: I): Command {
    const message = createBaseCommand();
    message.action = object.action ?? "";
    message.vessel = object.vessel ?? undefined;
    message.data = object.data?.map((e) => e) || [];
    message.ranges =
      object.ranges !== undefined && object.ranges !== null
        ? Ranges.fromPartial(object.ranges)
        : undefined;
    return message;
  },
};

function createBaseCommandResponse(): CommandResponse {
  return { success: false, error: undefined };
}

export const CommandResponse = {
  encode(
    message: CommandResponse,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.success === true) {
      writer.uint32(8).bool(message.success);
    }
    if (message.error !== undefined) {
      writer.uint32(18).string(message.error);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): CommandResponse {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseCommandResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.success = reader.bool();
          break;
        case 2:
          message.error = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): CommandResponse {
    return {
      success: isSet(object.success) ? Boolean(object.success) : false,
      error: isSet(object.error) ? String(object.error) : undefined,
    };
  },

  toJSON(message: CommandResponse): unknown {
    const obj: any = {};
    message.success !== undefined && (obj.success = message.success);
    message.error !== undefined && (obj.error = message.error);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<CommandResponse>, I>>(
    object: I
  ): CommandResponse {
    const message = createBaseCommandResponse();
    message.success = object.success ?? false;
    message.error = object.error ?? undefined;
    return message;
  },
};

type Builtin =
  | Date
  | Function
  | Uint8Array
  | string
  | number
  | boolean
  | undefined;

export type DeepPartial<T> = T extends Builtin
  ? T
  : T extends Array<infer U>
  ? Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U>
  ? ReadonlyArray<DeepPartial<U>>
  : T extends {}
  ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin
  ? P
  : P & { [K in keyof P]: Exact<P[K], I[K]> } & Record<
        Exclude<keyof I, KeysOfUnion<P>>,
        never
      >;

function longToString(long: Long) {
  return long.toString();
}

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
