/* eslint-disable */
import Long from "long";
import _m0 from "protobufjs/minimal";

export const protobufPackage = "";

export interface MetaDataRequest {
  variable: string[];
  from?: string | undefined;
  to?: string | undefined;
}

export interface MetaDataRange {
  from: string;
  to: string;
}

export interface MetaDataList {
  variable: string;
  ranges: MetaDataRange[];
}

export interface MetaDataResponse {
  metadata: MetaDataList[];
  error?: string | undefined;
}

function createBaseMetaDataRequest(): MetaDataRequest {
  return { variable: [], from: undefined, to: undefined };
}

export const MetaDataRequest = {
  encode(
    message: MetaDataRequest,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    for (const v of message.variable) {
      writer.uint32(10).string(v!);
    }
    if (message.from !== undefined) {
      writer.uint32(16).int64(message.from);
    }
    if (message.to !== undefined) {
      writer.uint32(24).int64(message.to);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MetaDataRequest {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMetaDataRequest();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.variable.push(reader.string());
          break;
        case 2:
          message.from = longToString(reader.int64() as Long);
          break;
        case 3:
          message.to = longToString(reader.int64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MetaDataRequest {
    return {
      variable: Array.isArray(object?.variable)
        ? object.variable.map((e: any) => String(e))
        : [],
      from: isSet(object.from) ? String(object.from) : undefined,
      to: isSet(object.to) ? String(object.to) : undefined,
    };
  },

  toJSON(message: MetaDataRequest): unknown {
    const obj: any = {};
    if (message.variable) {
      obj.variable = message.variable.map((e) => e);
    } else {
      obj.variable = [];
    }
    message.from !== undefined && (obj.from = message.from);
    message.to !== undefined && (obj.to = message.to);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<MetaDataRequest>, I>>(
    object: I
  ): MetaDataRequest {
    const message = createBaseMetaDataRequest();
    message.variable = object.variable?.map((e) => e) || [];
    message.from = object.from ?? undefined;
    message.to = object.to ?? undefined;
    return message;
  },
};

function createBaseMetaDataRange(): MetaDataRange {
  return { from: "0", to: "0" };
}

export const MetaDataRange = {
  encode(
    message: MetaDataRange,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.from !== "0") {
      writer.uint32(8).int64(message.from);
    }
    if (message.to !== "0") {
      writer.uint32(16).int64(message.to);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MetaDataRange {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMetaDataRange();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.from = longToString(reader.int64() as Long);
          break;
        case 2:
          message.to = longToString(reader.int64() as Long);
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MetaDataRange {
    return {
      from: isSet(object.from) ? String(object.from) : "0",
      to: isSet(object.to) ? String(object.to) : "0",
    };
  },

  toJSON(message: MetaDataRange): unknown {
    const obj: any = {};
    message.from !== undefined && (obj.from = message.from);
    message.to !== undefined && (obj.to = message.to);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<MetaDataRange>, I>>(
    object: I
  ): MetaDataRange {
    const message = createBaseMetaDataRange();
    message.from = object.from ?? "0";
    message.to = object.to ?? "0";
    return message;
  },
};

function createBaseMetaDataList(): MetaDataList {
  return { variable: "", ranges: [] };
}

export const MetaDataList = {
  encode(
    message: MetaDataList,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    if (message.variable !== "") {
      writer.uint32(10).string(message.variable);
    }
    for (const v of message.ranges) {
      MetaDataRange.encode(v!, writer.uint32(18).fork()).ldelim();
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MetaDataList {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMetaDataList();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.variable = reader.string();
          break;
        case 2:
          message.ranges.push(MetaDataRange.decode(reader, reader.uint32()));
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MetaDataList {
    return {
      variable: isSet(object.variable) ? String(object.variable) : "",
      ranges: Array.isArray(object?.ranges)
        ? object.ranges.map((e: any) => MetaDataRange.fromJSON(e))
        : [],
    };
  },

  toJSON(message: MetaDataList): unknown {
    const obj: any = {};
    message.variable !== undefined && (obj.variable = message.variable);
    if (message.ranges) {
      obj.ranges = message.ranges.map((e) =>
        e ? MetaDataRange.toJSON(e) : undefined
      );
    } else {
      obj.ranges = [];
    }
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<MetaDataList>, I>>(
    object: I
  ): MetaDataList {
    const message = createBaseMetaDataList();
    message.variable = object.variable ?? "";
    message.ranges =
      object.ranges?.map((e) => MetaDataRange.fromPartial(e)) || [];
    return message;
  },
};

function createBaseMetaDataResponse(): MetaDataResponse {
  return { metadata: [], error: undefined };
}

export const MetaDataResponse = {
  encode(
    message: MetaDataResponse,
    writer: _m0.Writer = _m0.Writer.create()
  ): _m0.Writer {
    for (const v of message.metadata) {
      MetaDataList.encode(v!, writer.uint32(10).fork()).ldelim();
    }
    if (message.error !== undefined) {
      writer.uint32(18).string(message.error);
    }
    return writer;
  },

  decode(input: _m0.Reader | Uint8Array, length?: number): MetaDataResponse {
    const reader = input instanceof _m0.Reader ? input : new _m0.Reader(input);
    let end = length === undefined ? reader.len : reader.pos + length;
    const message = createBaseMetaDataResponse();
    while (reader.pos < end) {
      const tag = reader.uint32();
      switch (tag >>> 3) {
        case 1:
          message.metadata.push(MetaDataList.decode(reader, reader.uint32()));
          break;
        case 2:
          message.error = reader.string();
          break;
        default:
          reader.skipType(tag & 7);
          break;
      }
    }
    return message;
  },

  fromJSON(object: any): MetaDataResponse {
    return {
      metadata: Array.isArray(object?.metadata)
        ? object.metadata.map((e: any) => MetaDataList.fromJSON(e))
        : [],
      error: isSet(object.error) ? String(object.error) : undefined,
    };
  },

  toJSON(message: MetaDataResponse): unknown {
    const obj: any = {};
    if (message.metadata) {
      obj.metadata = message.metadata.map((e) =>
        e ? MetaDataList.toJSON(e) : undefined
      );
    } else {
      obj.metadata = [];
    }
    message.error !== undefined && (obj.error = message.error);
    return obj;
  },

  fromPartial<I extends Exact<DeepPartial<MetaDataResponse>, I>>(
    object: I
  ): MetaDataResponse {
    const message = createBaseMetaDataResponse();
    message.metadata =
      object.metadata?.map((e) => MetaDataList.fromPartial(e)) || [];
    message.error = object.error ?? undefined;
    return message;
  },
};

type Builtin =
  | Date
  | Function
  | Uint8Array
  | string
  | number
  | boolean
  | undefined;

export type DeepPartial<T> = T extends Builtin
  ? T
  : T extends Array<infer U>
  ? Array<DeepPartial<U>>
  : T extends ReadonlyArray<infer U>
  ? ReadonlyArray<DeepPartial<U>>
  : T extends {}
  ? { [K in keyof T]?: DeepPartial<T[K]> }
  : Partial<T>;

type KeysOfUnion<T> = T extends T ? keyof T : never;
export type Exact<P, I extends P> = P extends Builtin
  ? P
  : P & { [K in keyof P]: Exact<P[K], I[K]> } & Record<
        Exclude<keyof I, KeysOfUnion<P>>,
        never
      >;

function longToString(long: Long) {
  return long.toString();
}

if (_m0.util.Long !== Long) {
  _m0.util.Long = Long as any;
  _m0.configure();
}

function isSet(value: any): boolean {
  return value !== null && value !== undefined;
}
