import express from 'express'
import discover from '../../../handlers/requests/discover'
import { HCFail } from '../../../services/cache/healthCheckMiddleware'

const route = express.Router({ mergeParams: true })

route.get('/', async (req, res) => {
  const { vessel } = (req.params as any)
  if (vessel == null) return res.send('Missing vessel from path')
  if (!/^\w+$/i.test(vessel)) return res.send(`Invalid vessel: "${vessel}"`)

  try {
    const data = await discover(vessel)
    res.send(data)
  } catch (e: any) {
    if (e.message === HCFail) {
      res.status(503)
      res.send(HCFail)
    } else {
      res.status(500)
      res.send(e.message)
    }
  }
})

export default route
