import express from 'express'
import getMetaData from '../../../handlers/metadata/getMetaData'

const route = express.Router({ mergeParams: true })

route.get('/:data', async (req, res) => {
  const from = parseInt(req.query.from as string)
  const to = parseInt(req.query.to as string)

  if (Number.isNaN(from)) {
    res.status(400)
    res.send('Invalid number: ' + req.query.from)
  }
  if (Number.isNaN(to)) {
    res.status(400)
    res.send('Invalid number: ' + req.query.to)
  }

  const vessel = (req.params as any).vessel

  if (!vessel) {
    res.send('Missing vessel parameter')
  }

  const data = req.params.data?.split(',')

  try {
    const response = await getMetaData(vessel, from, to, data)
    res.send(response)
  } catch (e) {
    res.status(500)
    res.send(e)
  }
})

export default route
