import mqtt from 'mqtt';
export interface MqttPoolClient extends mqtt.MqttClient {
}
export declare class Queue<T> {
    length: number;
    private head;
    private tail;
    enqueue(value: T): void;
    dequeue(): T;
}
export declare class QueueNode<T> {
    private next;
    private value;
    constructor(value: T);
    setNext(node: QueueNode<T>): void;
    getNext(): QueueNode<T> | undefined;
    getValue(): T;
}
export default class MqttPool {
    private static readonly maxClients;
    private static clientCount;
    private static queue;
    private static waiting;
    static get(): Promise<MqttPoolClient>;
    static release(client: MqttPoolClient): void;
}
